package com.sjls.nstthh;


import com.sjls.nstthh.entity.Scantask;
import com.sjls.nstthh.service.CommConfig;
import com.sjls.nstthh.service.NRJavaSerialManager;
import com.sjls.nstthh.service.ScantaskService;
import gnu.io.NRSerialPort;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import java.io.IOException;
import java.util.TooManyListenersException;


@SpringBootApplication
public class NstthhApplication {

    private static final Logger logger = LoggerFactory.getLogger(NstthhApplication.class);

    private static ScantaskService scantaskService;

    public static void main(String[] args) throws TooManyListenersException, IOException, InterruptedException {
        SpringApplication.run(NstthhApplication.class, args);
        //start();

    }
    public static void start() throws TooManyListenersException, IOException, InterruptedException {
        String port = "/dev/tty.usbserial-14130";//   /dev/ttyUSB0

        CommConfig.serialPort = new NRSerialPort(port, 9600);
        NRSerialPort serialPort = CommConfig.serialPort;
        serialPort.connect();
        NRJavaSerialManager.setDiameter(2);
        NRJavaSerialManager.setHigh(1);
        Scantask scantask = scantaskService.creatScanTask(serialPort);

    }

    @Autowired
    public void setScantaskService(ScantaskService scantaskService) {
        this.scantaskService = scantaskService;
    }
}
