package com.sjls.nstthh.controller;

import cn.hutool.core.util.StrUtil;
import com.sjls.nstthh.entity.Scantask;
import com.sjls.nstthh.service.CommConfig;
import com.sjls.nstthh.service.CommunicationService;
import com.sjls.nstthh.service.NRJavaSerialManager;
import com.sjls.nstthh.service.ScantaskService;
import gnu.io.NRSerialPort;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.Set;
import java.util.TooManyListenersException;

/**
 * smp admin
 */

@Controller
public class HardwareAdmin {
    private static final Logger logger = LoggerFactory.getLogger(HardwareAdmin.class);

    public NRSerialPort serialPort = null;

    private CommunicationService communicationService;
    private ScantaskService scantaskService;

    private NRJavaSerialManager nRJavaSerialManager;

    @Autowired
    public void setnRJavaSerialManager(NRJavaSerialManager nRJavaSerialManager) {
        this.nRJavaSerialManager = nRJavaSerialManager;
    }

    @Autowired
    public void setCommunicationService(CommunicationService communicationService) {
        this.communicationService = communicationService;
    }

    @Autowired
    public void setScantaskService(ScantaskService scantaskService) {
        this.scantaskService = scantaskService;
    }

    @RequestMapping("")
    public String index(Model model) {
//        model.addAttribute("scantaskList", scantaskService.getScantask());
//        Page<Scantask> pageS = scantaskService.getScantaskPage(0,10,"creatTime");
//        model.addAttribute("scantaskList", pageS);
//        logger.info("total{}",pageS.getTotalElements());
        model.addAttribute("total", scantaskService.getScantaskCount());
        return "index";
    }

    @RequestMapping("/scantask_d")
    @ResponseBody
    public Page<Scantask> scantask_d(int pageIndex) {
        //logger.info("scantask_d {}", pageIndex);
        return scantaskService.getScantaskPage(pageIndex-1, 10);
    }

    @RequestMapping("/admin")
    public String admin(Model model) {
        Set<String> set = NRSerialPort.getAvailableSerialPorts();
        model.addAttribute("portsSet", set);
        if (serialPort != null) {
            model.addAttribute("serialPort", true);
        }
        return "nstthh";
    }

    /**
     * 打点
     *
     * @param diameter
     * @param high
     * @throws TooManyListenersException
     * @throws IOException
     * @throws InterruptedException
     */
    @RequestMapping("/mtest")
    @ResponseBody
    public void mtest(Double diameter, Double high, Double h1, Double h2) throws TooManyListenersException, IOException, InterruptedException {
        if (diameter != null && diameter > 0)
            NRJavaSerialManager.setDiameter(diameter);
        if (high != null && high > 0)
            NRJavaSerialManager.setHigh(high);
        if (h1 != null && h1 > 0)
            NRJavaSerialManager.setH1(h1);
        if (h2 != null && h2 > 0)
            NRJavaSerialManager.setH2(h2);


        if (serialPort != null) {
            Scantask scantask = scantaskService.creatScanTask(serialPort);
        }

    }

    /**
     * 连串口
     *
     * @param port /dev/ttyUSB0
     * @return
     */

    @GetMapping("/scom")
    @ResponseBody
    public boolean scom(String port) {
        boolean b = false;
        if (!StrUtil.isEmpty(port) && CommConfig.serialPort == null) {
            CommConfig.serialPort = new NRSerialPort(port, 9600);
            serialPort = CommConfig.serialPort;
            b = serialPort.connect();
            logger.info("connect serialPort {} ", b);
        }
        return b;
    }

    /**
     * 关闭串口
     */
    @GetMapping("/ccom")
    @ResponseBody
    public void ccom() {
        try {
            if (serialPort != null) {
                serialPort.disconnect();
                //CommConfig.serialPort.disconnect();
                CommConfig.serialPort = null;
                serialPort = null;
                logger.info("close serialPort {} , {}", CommConfig.serialPort, serialPort);
            }
        } catch (Exception e) {
            //e.printStackTrace();
            return;
        }

    }


    @GetMapping("/sync-v2xyy")
    @ResponseBody
    public void v2xyy(Long id) throws UnsupportedEncodingException {
        Scantask scantask = new Scantask();
        scantask.setId(5L);
        //nRJavaSerialManager.setCommunicationService(communicationService);
        nRJavaSerialManager.setScantask(scantask);
        nRJavaSerialManager.synctoCloudData();
    }
}

