package com.sjls.nstthh.service;

import cn.hutool.core.date.DateUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.io.IOException;
import java.util.TooManyListenersException;

@Configuration
@EnableScheduling
public class SaticScheduleTask {


    private static final Logger logger = LoggerFactory.getLogger(SaticScheduleTask.class);
    private CommunicationService communicationService;
    private ScantaskService scantaskService;

    @Autowired
    public void setCommunicationService(CommunicationService communicationService) {
        this.communicationService = communicationService;
    }

    @Autowired
    public void setScantaskService(ScantaskService scantaskService) {
        this.scantaskService = scantaskService;
    }

    //3.添加定时任务
    // 每天的18点、21点都执行一次：0 0 09,18 * * ?
    @Scheduled(cron = "0 0 7,17 * * ?")
    //或直接指定时间间隔，例如：5秒
    //@Scheduled(fixedRate=360000)
    private void configureTasks() throws TooManyListenersException, IOException, InterruptedException {

        //for (String s : NRSerialPort.getAvailableSerialPorts()) {
        //logger.info(" Availible port: " + s);
        //}

        // /dev/ttyUSB0     /dev/tty.usbserial-14130
        //todo 手动连接串口

        if (CommConfig.serialPort != null && CommConfig.serialPort.isConnected()) {
            logger.info("{} :定时扫描任务开启......", DateUtil.now());
            scantaskService.creatScanTask(CommConfig.serialPort);
            logger.info("{} :定时扫描任务结束......", DateUtil.now());

        } else {
            logger.info("{} :定时扫描任务未开启，手动链接串口......", DateUtil.now());
        }

        //System.err.println("执行静态定时任务时间: " + LocalDateTime.now());
    }


}