package com.sjls.nstthh.service;

import cn.hutool.core.date.DateTime;
import com.sjls.nstthh.entity.Scantask;
import com.sjls.nstthh.repository.ScantaskRepository;
import com.sjls.nstthh.util.SnowflakeIdWorker;
import gnu.io.NRSerialPort;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import java.beans.Transient;
import java.io.IOException;
import java.util.List;

@Service
public class ScantaskService {
    private static final Logger logger = LoggerFactory.getLogger(ScantaskService.class);

    private static long current_scantaskId = 0;

    private ScantaskRepository scantaskRepository;
    private NRJavaSerialManager nRJavaSerialManager;

    @Autowired
    public void setScantaskRepository(ScantaskRepository scantaskRepository) {
        this.scantaskRepository = scantaskRepository;
    }

    @Autowired
    public void setnRJavaSerialManager(NRJavaSerialManager nRJavaSerialManager) {
        this.nRJavaSerialManager = nRJavaSerialManager;
    }

    /**
     * @return
     */
    public List<Scantask> getScantask() {
        List<Scantask> list = scantaskRepository.findAll();
        return list;
    }
    public long getScantaskCount() {
        return scantaskRepository.count();
    }

    public Page<Scantask> getScantaskPage(int cpage, int size) {
       // Page<Scantask> page = scantaskRepository.findAll(PageRequest.of(cpage, size, Sort.by(Sort.Order.desc("id"),Sort.Order.desc("creatTime"))));
        Page<Scantask> page = scantaskRepository.findAll(PageRequest.of(cpage, size, Sort.Direction.DESC,"creatTime"));

        //logger.info("......{},{},{},{}",page.getContent(),page.getTotalElements(),page.getTotalPages(),page.getSize());
        return page;
    }

    @Transient
    public Scantask creatScanTask(NRSerialPort serialPort) throws  IOException, InterruptedException {
        boolean flag = true;
        if (current_scantaskId > 0) {
            Scantask c_scantaskdb = scantaskRepository.getById(current_scantaskId);
            if (c_scantaskdb.isOver()) {
                flag = true;
            } else {
                logger.info("Wait for the last task to complete ......");
                flag = false;
            }
        }

        Scantask scantaskdb = null;
        if (flag) {
            long id = new SnowflakeIdWorker(0, 0).nextId();
            Scantask scantask = new Scantask();
            scantask.setStkey(String.valueOf(id));
            scantask.setCreatTime(DateTime.now());
            scantaskdb = scantaskRepository.saveAndFlush(scantask);
            current_scantaskId = scantaskdb.getId();
            nRJavaSerialManager.setScantask(scantaskdb);
            nRJavaSerialManager.operation(serialPort);
        }

        return scantaskdb;
    }
}
